/*Class definition: The HarryPotter class extends the GameCharacter class. 
 * This class represents our hero Harry who has to thread his way across the treacherous 
 * maze. Remember Harry can use his spellPoints (which he earns when he picks up Scrolls)
 * to cast spells. This class has some standard accessor and mutator methods to set and return the 
 * spellPoints gathered by Harry. 
 */
public class HarryPotter extends GameCharacter {
	int spellPoints = 20;

	public HarryPotter(String name, char displaySymbol, int xPos, int yPos) {
		super(name, displaySymbol, xPos, yPos);
	}
	//Returns true if Harry has cast a spell. Harry can cast a spell only when he has enough spell
	//points
	public boolean castSpell() {
		if (spellPoints >= 10) {
			processSpellPoints(10);
			return true;
		} else {
			return false;
		}
	}

	public int getSpellPoints() {
		return spellPoints;
	}

	public void setSpellPoints(int spellPoints) {
		this.spellPoints = spellPoints;
	}
	//Decreasing the spellPoints
	private void processSpellPoints(int points) {
		spellPoints -= points;
	}
	//Increasing the health
	public void addHealth(int points) {
		health += points;
	}
	//Adding spellPoints
	public void addSpellPoints(int points) {
		spellPoints += points;

	}
	//Adding attackPoints
	public void addAttackIndex(int points) {
		attackIndex += points;
	}
	//Adding to Harry's defenceIndex
	public void addDefenceIndex(int points) {
		defenceIndex += points;
	}
	public String toString() {
		return name + "[Health("+health+"):Attack("+attackIndex+"):Defence("+defenceIndex+"):SpellPoints("+spellPoints+")]";
	}

} //End of class definition